// Scramble.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Scramble.h"
#include "ScrambleDlg.h"
#include "IntroDlg.h"
#include "stdio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CScrambleApp

BEGIN_MESSAGE_MAP(CScrambleApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CScrambleApp construction

CScrambleApp::CScrambleApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CScrambleApp object

CScrambleApp theApp;


// CScrambleApp initialization

BOOL CScrambleApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	IntroDlg sIntroDlg;
	INT_PTR nResponse = sIntroDlg.DoModal ();

	if (nResponse == IDOK)
	{
		//CScrambleDlg sExitDlg;

		Scramble ();

		//m_pMainWnd = & sExitDlg;
		//nResponse = sExitDlg.DoModal ();
		//if (nResponse == IDOK)
		//{
		//	// TODO: Place code here to handle when the dialog is
		//	//  dismissed with OK
		//}
		//else if (nResponse == IDCANCEL)
		//{
		//	// TODO: Place code here to handle when the dialog is
		//	//  dismissed with Cancel
		//}
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

bool CScrambleApp::Scramble (void)
{
	char szFilter[] = "Text files (*.txt)\0*.txt\0All files (*.*)\0*.*\0\0";
	char szExt[] = "txt";
	char *szFileIn;
	char *szFileOut;
	bool boSuccess = false;
	CFileDialog dlgOpen(true);
	dlgOpen.m_ofn.Flags |= (OFN_PATHMUSTEXIST | OFN_ENABLESIZING | OFN_FILEMUSTEXIST);
	dlgOpen.m_ofn.lpstrFilter = szFilter;

	if (dlgOpen.DoModal() == IDOK)
	{
		szFileIn = dlgOpen.m_ofn.lpstrFile;
	    _RPTF1(_CRT_WARN, "\n\n File in is %s\n\n", szFileIn);

		CFileDialog dlgSave(false);
		dlgSave.m_ofn.Flags |= (OFN_PATHMUSTEXIST | OFN_ENABLESIZING | OFN_FILEMUSTEXIST);
		dlgSave.m_ofn.lpstrFilter = szFilter;
		dlgSave.m_ofn.lpstrDefExt = szExt;
		if (dlgSave.DoModal() == IDOK)
		{
			szFileOut = dlgSave.m_ofn.lpstrFile;
		    _RPTF1(_CRT_WARN, "\n\n File out is %s\n\n", szFileOut);
			if (strcmp (szFileIn, szFileOut) == 0)
			{
				AfxMessageBox("Input and output files must be distinct");
			}
			else
			{
				// Scramble the file!
				srand( (unsigned)time( NULL ) );
				FILE * fhFileIn;
				fhFileIn = fopen (szFileIn, "r");
				if (fhFileIn)
				{
					FILE * fhFileOut;
					fhFileOut = fopen (szFileOut, "w");
					if (fhFileOut)
					{
						int nChar;
						bool boMore = true;
						char szWord[1024];
						nChar = fgetc (fhFileIn);
						if (nChar == EOF)
						{
							boMore = false;
						}
						boSuccess = true;
						while (boMore)
						{
							if (strchr ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz", nChar))
							{
								// We've hit a word, so...
								szWord[0] = (char)nChar;
								int nPos = 1;
								do
								{
									nChar = fgetc (fhFileIn);
									szWord[nPos] = (char)nChar;
									nPos++;
								} while ((nPos < sizeof (szWord))
									&& strchr ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz", nChar));
								nPos--;

								if (nPos > 2)
								{
									int	nRand1;
									int	nRand2;
									char cChar;
									// Scramble the word up
									for (int nCount = 0; nCount < (nPos -2); nCount++)
									{
										nRand1 = 1 + (rand () % (nPos - 2));
										nRand2 = 1 + (rand () % (nPos - 2));
										cChar = szWord[nRand1];
										szWord[nRand1] = szWord[nRand2];
										szWord[nRand2] = cChar;
									}
								}

								// Output the word
								for (int nOutPos = 0; nOutPos < nPos; nOutPos++)
								{
									fputc (szWord[nOutPos], fhFileOut);
								}
								if (nChar != EOF)
								{
									fputc (nChar, fhFileOut);
								}
								else
								{
									boMore = false;
								}
							}
							else
							{
								// Not a word, so dump the character to the output file
								if (nChar == EOF)
								{
									boMore = false;
								}
								else
								{
									fputc (nChar, fhFileOut);
								}
							}
							if (boMore)
							{
								nChar = fgetc (fhFileIn);
							}
						}
						fclose (fhFileOut);
					}
					else
					{
						AfxMessageBox("Could not open output file");
					}
					fclose (fhFileIn);
				}
				else
				{
					AfxMessageBox("Could not open input file");
				}
			}
		}
	}
	return boSuccess;
}